import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import java.lang.*;

 
class LocalClassLoader extends ClassLoader {
    /** This is the directory from which the classes will be loaded */
    String directory;
    byte   []classbytes;
  
    /** The constructor.  Just initialize the directory */
    public LocalClassLoader(String dir) { directory = dir; }

    /** A convenience method that calls the 2-argument form of this method */
    public Class loadClass(String name) throws ClassNotFoundException { 
      return loadClass(name, true); 
    }

 public byte[] getClassContent(String name)
   throws ClassNotFoundException
  {
     Class myclass = loadClass(name);
     return classbytes;
        
  }

public void setDirectory(String dir)
  {
     directory = dir; 
  }
  

    /**
     * This is one abstract method of ClassLoader that all subclasses must
     * define.  Its job is to load an array of bytes from somewhere and to
    * pass them to defineClass().  If the resolve argument is true, it must
     * also call resolveClass(), which will do things like verify the presence
     * of the superclass.  Because of this second step, this method may be
     * called to load superclasses that are system classes, and it must take 
     * this into account.
     **/
    public Class loadClass(String classname, boolean resolve) 
      throws ClassNotFoundException {
      try {
        // Our ClassLoader superclass has a built-in cache of classes it has
        // already loaded.  So, first check the cache.
        Class c = findLoadedClass(classname);

        // If the class wasn't found by either of the above attempts, then
        // try to load it from a file in (or beneath) the directory
        // specified when this ClassLoader object was created.  Form the
        // filename by replacing all dots in the class name with
        // (platform-independent) file separators and by adding the
        // ".class" extension.
        if (c == null) {
          // Figure out the filename
          String filename = classname.replace('.',File.separatorChar)+".class";

          // Create a File object.  Interpret the filename relative to the
          // directory specified for this ClassLoader.
          File f = new File(directory, filename);

          // Get the length of the class file, allocate an array of bytes for
          // it, and read it in all at once.
          int length = (int) f.length();
          classbytes = new byte[length];
          DataInputStream in = new DataInputStream(new FileInputStream(f));
          in.readFully(classbytes);
          in.close();

          // Now call an inherited method to convert those bytes into a Class
          c = defineClass(classname, classbytes, 0, length);
        }

        // If the resolve argument is true, call the inherited resolveClass
        // method.
        if (resolve) resolveClass(c);

        // And we're done.  Return the Class object we've loaded.
        return c;
      }
      // If anything goes wrong, throw a ClassNotFoundException error
      catch (Exception e) { throw new ClassNotFoundException(e.toString()); }
    }
  }

 
